Loading...
Searching...
No Matches
Ogre::SubEntity Class Reference
Core » Scene

Utility class which defines the sub-parts of an Entity. More...

`#include <OgreSubEntity.h>`

Inheritance diagram for Ogre::SubEntity:
[legend]

## Public Member Functions

bool | _getBuffersMarkedForAnimation (void) const
| Are buffers already marked as vertex animated?
VertexData * | _getHardwareVertexAnimVertexData (void)
| Advanced method to get the hardware morph vertex information.
VertexData * | _getSkelAnimVertexData (void)
| Advanced method to get the temporarily blended vertex information for entities which are software skinned.
VertexData * | _getSoftwareVertexAnimVertexData (void)
| Advanced method to get the temporarily blended software morph vertex information.
void | _invalidateCameraCache ()
| Invalidate the camera distance cache.
void | _markBuffersUnusedForAnimation (void)
| Mark all vertex data as so far unanimated.
void | _markBuffersUsedForAnimation (void)
| Mark all vertex data as animated.
void | _restoreBuffersForUnusedAnimation (bool hardwareAnimation)
| Internal method to copy original vertex data to the morph structures should there be no active animation in use.
void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const override
| Overridden from Renderable to provide some custom behaviour.
bool | getCastsShadows (void) const override
| Method which reports whether this renderable would normally cast a shadow.
uint32 | getIndexDataEndIndex () const
uint32 | getIndexDataStartIndex () const
const LightList & | getLights (void) const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial (void) const override
| Retrieves a weak reference to the material this renderable object uses.
const String & | getMaterialName () const
| Gets the name of the Material in use by this instance.
unsigned short | getNumWorldTransforms (void) const override
| Returns the number of world transform matrices this renderable requires.
Entity * | getParent (void) const
| Accessor to get parent Entity.
void | getRenderOperation (RenderOperation &op) override
| Gets the render operation required to send this object to the frame buffer.
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
ushort | getRenderQueuePriority (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
Real | getSquaredViewDepth (const Camera *cam) const override
| Returns the squared distance between the camera and this renderable.
SubMesh * | getSubMesh (void) const
| Accessor method to read mesh data.
VertexData * | getVertexDataForBinding (void)
| Retrieve the VertexData which should be used for GPU binding.
void | getWorldTransforms (Matrix4 *xform) const override
| Gets the world transform matrix / matrices for this renderable object.
bool | isRenderQueueGroupSet (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
bool | isRenderQueuePrioritySet (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
bool | isVisible (void) const
| Returns whether or not this SubEntity is supposed to be visible.
void | resetIndexDataStartEndIndex ()
| Reset the custom start/end index to the default values.
void | setIndexDataEndIndex (uint32 end_index)
void | setIndexDataStartIndex (uint32 start_index)
void | setMaterial (const MaterialPtr &material)
| Sets the name of the Material to be used.
void | setMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Sets the name of the Material to be used.
void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this SubEntity will be rendered through.
void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this SubEntity will be rendered through.
void | setVisible (bool visible)
| Tells this SubEntity whether to be visible or not.
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
uint16 | _getMaterialLodIndex () const
const Vector4f & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4f &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
void | setUserAny (const Any &anything)

## Additional Inherited Members

Public Types inherited from Ogre::Renderable
enum | { DEFAULT_PRIORITY = 100 }

## Detailed Description

Utility class which defines the sub-parts of an Entity.

Just as meshes are split into submeshes, an Entity is made up of potentially multiple SubMeshes. These are mainly here to provide the link between the Material which the SubEntity uses (which may be the default Material for the SubMesh or may have been changed for this object) and the SubMesh data.

  The SubEntity also allows the application some flexibility in the material properties for this section of a particular instance of this Mesh, e.g. tinting the windows on a car model.

  SubEntity instances are never created manually. They are created at the same time as their parent Entity by the SceneManager method createEntity.

## Member Function Documentation

## getMaterialName()

const String & Ogre::SubEntity::getMaterialName | ( |  | ) | const

Gets the name of the Material in use by this instance.

## setMaterialName()

void Ogre::SubEntity::setMaterialName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

Sets the name of the Material to be used.

By default a SubEntity uses the default Material that the SubMesh uses. This call can alter that so that the Material is different for this instance.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## setMaterial()

void Ogre::SubEntity::setMaterial | ( | const MaterialPtr & | material | ) |

Sets the name of the Material to be used.

By default a SubEntity uses the default Material that the SubMesh uses. This call can alter that so that the Material is different for this instance.

## setVisible()

void Ogre::SubEntity::setVisible | ( | bool | visible | ) |

Tells this SubEntity whether to be visible or not.

## isVisible()

bool Ogre::SubEntity::isVisible | ( | void |  | ) | const

inline

Returns whether or not this SubEntity is supposed to be visible.

## setRenderQueueGroup()

void Ogre::SubEntity::setRenderQueueGroup | ( | uint8 | queueID | ) |

Sets the render queue group this SubEntity will be rendered through.

Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, the SubEntity will use either the Entity's queue or it will use the default (RenderQueue::getDefaultQueueGroup).

  See Entity::setRenderQueueGroup for more details.

Parameters

  queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.

## setRenderQueueGroupAndPriority()

void Ogre::SubEntity::setRenderQueueGroupAndPriority | ( | uint8 | queueID,
|  | ushort | priority )

Sets the render queue group and group priority this SubEntity will be rendered through.

Render queues are grouped to allow you to more tightly control the ordering of rendered objects. Within a single render group there another type of grouping called priority which allows further control. If you do not call this method, all Entity objects default to the default queue and priority (RenderQueue::getDefaultQueueGroup, RenderQueue::getDefaultRenderablePriority).

  See Entity::setRenderQueueGroupAndPriority for more details.

Parameters

  queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.
  priority | The priority within a group to use.

## getRenderQueueGroup()

uint8 Ogre::SubEntity::getRenderQueueGroup | ( | void |  | ) | const

inline

Gets the queue group for this entity, see setRenderQueueGroup for full details.

## getRenderQueuePriority()

ushort Ogre::SubEntity::getRenderQueuePriority | ( | void |  | ) | const

inline

Gets the queue group for this entity, see setRenderQueueGroup for full details.

## isRenderQueueGroupSet()

bool Ogre::SubEntity::isRenderQueueGroupSet | ( | void |  | ) | const

inline

Gets the queue group for this entity, see setRenderQueueGroup for full details.

## isRenderQueuePrioritySet()

bool Ogre::SubEntity::isRenderQueuePrioritySet | ( | void |  | ) | const

inline

Gets the queue group for this entity, see setRenderQueueGroup for full details.

## getSubMesh()

SubMesh * Ogre::SubEntity::getSubMesh | ( | void |  | ) | const

inline

Accessor method to read mesh data.

## getParent()

Entity * Ogre::SubEntity::getParent | ( | void |  | ) | const

inline

Accessor to get parent Entity.

References Entity.

## getMaterial()

const MaterialPtr & Ogre::SubEntity::getMaterial | ( | void |  | ) | const

inline override virtual

Retrieves a weak reference to the material this renderable object uses.

Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.

Implements Ogre::Renderable.

## getRenderOperation()

void Ogre::SubEntity::getRenderOperation | ( | RenderOperation & | op | ) |

override virtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## setIndexDataStartIndex()

void Ogre::SubEntity::setIndexDataStartIndex | ( | uint32 | start_index | ) |

Deprecated
  api about to be removed

## getIndexDataStartIndex()

uint32 Ogre::SubEntity::getIndexDataStartIndex | ( |  | ) | const

inline

Deprecated
  api about to be removed

## setIndexDataEndIndex()

void Ogre::SubEntity::setIndexDataEndIndex | ( | uint32 | end_index | ) |

Deprecated
  api about to be removed

## getIndexDataEndIndex()

uint32 Ogre::SubEntity::getIndexDataEndIndex | ( |  | ) | const

inline

Deprecated
  api about to be removed

## resetIndexDataStartEndIndex()

void Ogre::SubEntity::resetIndexDataStartEndIndex | ( |  | ) |

Reset the custom start/end index to the default values.

## getWorldTransforms()

void Ogre::SubEntity::getWorldTransforms | ( | Matrix4 * | xform | ) | const

override virtual

Gets the world transform matrix / matrices for this renderable object.

If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

This method will populate transform with 1 matrix if it does not use GPU vertex blending. If it does use GPU vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  If MeshManager::getBonesUseObjectSpace() is true, the first matrix must contain the world transform of the object, and the rest of the matrices must contain the bone transforms in object space.

Implements Ogre::Renderable.

## getNumWorldTransforms()

unsigned short Ogre::SubEntity::getNumWorldTransforms | ( | void |  | ) | const

override virtual

Returns the number of world transform matrices this renderable requires.

When a renderable uses GPU vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Note
  If MeshManager::getBonesUseObjectSpace() is true, this method must return numBones + 1

Reimplemented from Ogre::Renderable.

## getSquaredViewDepth()

Real Ogre::SubEntity::getSquaredViewDepth | ( | const Camera * | cam | ) | const

override virtual

Returns the squared distance between the camera and this renderable.

Used to sort transparent objects. Squared distance is used to avoid having to perform a square root on the result.

Implements Ogre::Renderable.

## getLights()

const LightList & Ogre::SubEntity::getLights | ( | void |  | ) | const

override virtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## getCastsShadows()

bool Ogre::SubEntity::getCastsShadows | ( | void |  | ) | const

override virtual

Method which reports whether this renderable would normally cast a shadow.

Subclasses should override this if they could have been used to generate a shadow.

Reimplemented from Ogre::Renderable.

## _getSkelAnimVertexData()

VertexData * Ogre::SubEntity::_getSkelAnimVertexData | ( | void |  | ) |

Advanced method to get the temporarily blended vertex information for entities which are software skinned.

Internal engine will eliminate software animation if possible, this information is unreliable unless added request for software animation via Entity::addSoftwareAnimationRequest.

Note
  The positions/normals of the returned vertex data is in object space.

## _getSoftwareVertexAnimVertexData()

VertexData * Ogre::SubEntity::_getSoftwareVertexAnimVertexData | ( | void |  | ) |

Advanced method to get the temporarily blended software morph vertex information.

Internal engine will eliminate software animation if possible, this information is unreliable unless added request for software animation via Entity::addSoftwareAnimationRequest.

Note
  The positions/normals of the returned vertex data is in object space.

## _getHardwareVertexAnimVertexData()

VertexData * Ogre::SubEntity::_getHardwareVertexAnimVertexData | ( | void |  | ) |

Advanced method to get the hardware morph vertex information.

Note
  The positions/normals of the returned vertex data is in object space.

## getVertexDataForBinding()

VertexData * Ogre::SubEntity::getVertexDataForBinding | ( | void |  | ) |

Retrieve the VertexData which should be used for GPU binding.

## _markBuffersUnusedForAnimation()

void Ogre::SubEntity::_markBuffersUnusedForAnimation | ( | void |  | ) |

Mark all vertex data as so far unanimated.

## _markBuffersUsedForAnimation()

void Ogre::SubEntity::_markBuffersUsedForAnimation | ( | void |  | ) |

Mark all vertex data as animated.

## _getBuffersMarkedForAnimation()

bool Ogre::SubEntity::_getBuffersMarkedForAnimation | ( | void |  | ) | const

inline

Are buffers already marked as vertex animated?

## _restoreBuffersForUnusedAnimation()

void Ogre::SubEntity::_restoreBuffersForUnusedAnimation | ( | bool | hardwareAnimation | ) |

Internal method to copy original vertex data to the morph structures should there be no active animation in use.

## _updateCustomGpuParameter()

void Ogre::SubEntity::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params ) const

override virtual

Overridden from Renderable to provide some custom behaviour.

Reimplemented from Ogre::Renderable.

## _invalidateCameraCache()

void Ogre::SubEntity::_invalidateCameraCache | ( |  | ) |

inline

Invalidate the camera distance cache.

The documentation for this class was generated from the following file:

- OgreSubEntity.h